﻿using System.Net;
using System.Runtime.Serialization;
using System.Text.Json.Serialization;

namespace Dto;

[DataContract]
public class LessonDTO
{
    [DataMember]
    public int Id { get; set; }
    [DataMember]
    public string? Title { get; set; }
    [DataMember]
    public string? LastPublisher { get; set; }
    [DataMember]
    public DateOnly? LastEdit { get; set; }
    [JsonIgnore(Condition = JsonIgnoreCondition.WhenWritingNull)]
    public ICollection<ContentLessonDto> Content { get; set; } = new List<ContentLessonDto>();

    public LessonDTO()
    {
    }

    public LessonDTO(int id, string title, string lastPublisher, DateOnly? lastEdit)
    {
        Id = id;
        Title = title;
        LastPublisher = lastPublisher;
        LastEdit = lastEdit;
    }
    
    public LessonDTO(int id, string title, string lastPublisher, DateOnly? lastEdit, ICollection<ContentLessonDto> content)
    {
        Id = id;
        Title = title;
        LastPublisher = lastPublisher;
        LastEdit = lastEdit;
        Content = content;
    }

    public LessonDTO(string title, string lastPublisher, DateOnly? lastEdit)
    {
        Title = title;
        LastPublisher = lastPublisher;
        LastEdit = lastEdit;
    }
}